<?php

require_once('Config.php');
require_once('syslog.php');

class FingerPrinter extends Config {

	protected $_data;
	protected $_syslog;

	function __construct() {
		$this->_data = "";
		$this->_syslog = new Syslog();

		$this->_syslog->SetFacility($this->facility);
		$this->_syslog->SetSeverity($this->severity);
		$this->_syslog->SetHostname($this->hostname);
		$this->_syslog->SetFqdn($this->hostname);
		$this->_syslog->SetServer($this->host);
		$this->_syslog->SetPort($this->port);
		$this->_syslog->SetIpFrom($this->ipaddress);
		$this->_syslog->SetProcess($this->process);
	}

	public function ProcessRequest() {

		$this->_data = "SourceAddress:" . $_SERVER["REMOTE_ADDR"];

		foreach($this->params as $param) {
			$this->_data = implode(
				",", 
				Array(
					$this->_data,
					$param . ':' . $this->_GenerateHash($_REQUEST[$param])
				)
			);
		}
		$this->_SendData();
	}

	private function _GenerateHash($input) {
		return sha1($input);
	}

	public function getData() {
		return $this->_data;
	}

	private function _SendData() {
		if ($this->debug) {
			echo "Debug:".$this->_data;
		}
		$this->_syslog->SetContent($this->_data);
		$this->_syslog->Send();

	}
}

?>
